/* utils.c generated by valac 0.56.14, the Vala compiler
 * generated from utils.vala, do not modify */

/*
Peek Copyright (c) 2015-2018 by Philipp Wolfer <ph.wolfer@gmail.com>

This file is part of Peek.

This software is licensed under the GNU General Public License
(version 3 or later). See the LICENSE file in this distribution.
*/
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include "../../application.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <stdio.h>
#include <glib/gstdio.h>
#include <unistd.h>
#include <glib-object.h>
#include <gobject/gvaluecollector.h>

#define PEEK_UTILS_NUMBER_FORMAT "%02" G_GINT64_MODIFIER "d"
#define PEEK_UTILS_TIME_FORMAT PEEK_UTILS_NUMBER_FORMAT ":" PEEK_UTILS_NUMBER_FORMAT

#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _fclose0(var) ((var == NULL) ? NULL : (var = (fclose (var), NULL)))
typedef struct _PeekParamSpecUtils PeekParamSpecUtils;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _PeekParamSpecUtils {
	GParamSpec parent_instance;
};

static gpointer peek_utils_parent_class = NULL;

static gchar* peek_utils_read_instream_as_utf8 (GInputStream* stream);
static void peek_utils_finalize (PeekUtils * obj);
static GType peek_utils_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

gchar*
peek_utils_get_temp_dir (void)
{
	gchar* cache_dir_path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GFile* cache_dir = NULL;
	const gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp12_;
	gchar* _tmp13_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 14 "../src/utils.vala"
	_tmp0_ = g_get_user_cache_dir ();
#line 14 "../src/utils.vala"
	_tmp1_ = g_build_filename (_tmp0_, "peek", NULL);
#line 14 "../src/utils.vala"
	cache_dir_path = _tmp1_;
#line 17 "../src/utils.vala"
	_tmp2_ = cache_dir_path;
#line 17 "../src/utils.vala"
	_tmp3_ = g_file_new_for_path (_tmp2_);
#line 17 "../src/utils.vala"
	cache_dir = _tmp3_;
#line 86 "utils.c"
	{
		GFile* _tmp4_;
#line 20 "../src/utils.vala"
		_tmp4_ = cache_dir;
#line 20 "../src/utils.vala"
		g_file_make_directory_with_parents (_tmp4_, NULL, &_inner_error0_);
#line 20 "../src/utils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 95 "utils.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
#line 19 "../src/utils.vala"
		e = _inner_error0_;
#line 19 "../src/utils.vala"
		_inner_error0_ = NULL;
#line 22 "../src/utils.vala"
		_tmp5_ = e;
#line 22 "../src/utils.vala"
		if (g_error_matches (_tmp5_, G_IO_ERROR, G_IO_ERROR_EXISTS)) {
#line 112 "utils.c"
			const gchar* _tmp6_;
#line 23 "../src/utils.vala"
			_tmp6_ = cache_dir_path;
#line 23 "../src/utils.vala"
			g_debug ("utils.vala:23: Cache directory does already exist %s\n", _tmp6_);
#line 118 "utils.c"
		} else {
			FILE* _tmp7_;
			GError* _tmp8_;
			const gchar* _tmp9_;
			const gchar* _tmp10_;
			gchar* _tmp11_;
#line 25 "../src/utils.vala"
			_tmp7_ = stderr;
#line 25 "../src/utils.vala"
			_tmp8_ = e;
#line 25 "../src/utils.vala"
			_tmp9_ = _tmp8_->message;
#line 25 "../src/utils.vala"
			fprintf (_tmp7_, "Error: %s\n", _tmp9_);
#line 26 "../src/utils.vala"
			_tmp10_ = g_get_tmp_dir ();
#line 26 "../src/utils.vala"
			_tmp11_ = g_strdup (_tmp10_);
#line 26 "../src/utils.vala"
			result = _tmp11_;
#line 26 "../src/utils.vala"
			_g_error_free0 (e);
#line 26 "../src/utils.vala"
			_g_object_unref0 (cache_dir);
#line 26 "../src/utils.vala"
			_g_free0 (cache_dir_path);
#line 26 "../src/utils.vala"
			return result;
#line 147 "utils.c"
		}
#line 19 "../src/utils.vala"
		_g_error_free0 (e);
#line 151 "utils.c"
	}
	__finally0:
#line 19 "../src/utils.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 19 "../src/utils.vala"
		_g_object_unref0 (cache_dir);
#line 19 "../src/utils.vala"
		_g_free0 (cache_dir_path);
#line 19 "../src/utils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 19 "../src/utils.vala"
		g_clear_error (&_inner_error0_);
#line 19 "../src/utils.vala"
		return NULL;
#line 166 "utils.c"
	}
#line 30 "../src/utils.vala"
	_tmp12_ = cache_dir;
#line 30 "../src/utils.vala"
	_tmp13_ = g_file_get_path (_tmp12_);
#line 30 "../src/utils.vala"
	result = _tmp13_;
#line 30 "../src/utils.vala"
	_g_object_unref0 (cache_dir);
#line 30 "../src/utils.vala"
	_g_free0 (cache_dir_path);
#line 30 "../src/utils.vala"
	return result;
#line 180 "utils.c"
}

gchar*
peek_utils_create_temp_file (const gchar* extension,
                             GError** error)
{
	gchar* temp_dir = NULL;
	gchar* _tmp0_;
	gchar* file_name = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gint fd = 0;
	gchar* result;
#line 33 "../src/utils.vala"
	g_return_val_if_fail (extension != NULL, NULL);
#line 34 "../src/utils.vala"
	_tmp0_ = peek_utils_get_temp_dir ();
#line 34 "../src/utils.vala"
	temp_dir = _tmp0_;
#line 35 "../src/utils.vala"
	_tmp1_ = g_strconcat ("peekXXXXXX.", extension, NULL);
#line 35 "../src/utils.vala"
	_tmp2_ = _tmp1_;
#line 35 "../src/utils.vala"
	_tmp3_ = g_build_filename (temp_dir, _tmp2_, NULL);
#line 35 "../src/utils.vala"
	_tmp4_ = _tmp3_;
#line 35 "../src/utils.vala"
	_g_free0 (_tmp2_);
#line 35 "../src/utils.vala"
	file_name = _tmp4_;
#line 36 "../src/utils.vala"
	fd = g_mkstemp (file_name);
#line 37 "../src/utils.vala"
	close (fd);
#line 38 "../src/utils.vala"
	g_debug ("utils.vala:38: Temp file: %s\n", file_name);
#line 39 "../src/utils.vala"
	result = file_name;
#line 39 "../src/utils.vala"
	_g_free0 (temp_dir);
#line 39 "../src/utils.vala"
	return result;
#line 226 "utils.c"
}

gboolean
peek_utils_is_exit_status_success (gint status)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
	{
		gboolean _tmp0_ = FALSE;
#line 44 "../src/utils.vala"
		_tmp0_ = g_spawn_check_exit_status (status, &_inner_error0_);
#line 44 "../src/utils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 240 "utils.c"
			goto __catch0_g_error;
		}
#line 44 "../src/utils.vala"
		if (_tmp0_) {
#line 45 "../src/utils.vala"
			result = TRUE;
#line 45 "../src/utils.vala"
			return result;
#line 249 "utils.c"
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		FILE* _tmp1_;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 43 "../src/utils.vala"
		e = _inner_error0_;
#line 43 "../src/utils.vala"
		_inner_error0_ = NULL;
#line 49 "../src/utils.vala"
		_tmp1_ = stderr;
#line 49 "../src/utils.vala"
		_tmp2_ = e;
#line 49 "../src/utils.vala"
		_tmp3_ = _tmp2_->message;
#line 49 "../src/utils.vala"
		fprintf (_tmp1_, "Error: %s\n", _tmp3_);
#line 43 "../src/utils.vala"
		_g_error_free0 (e);
#line 273 "utils.c"
	}
	__finally0:
#line 43 "../src/utils.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 278 "utils.c"
		gboolean _tmp4_ = FALSE;
#line 43 "../src/utils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 43 "../src/utils.vala"
		g_clear_error (&_inner_error0_);
#line 43 "../src/utils.vala"
		return _tmp4_;
#line 286 "utils.c"
	}
#line 52 "../src/utils.vala"
	result = FALSE;
#line 52 "../src/utils.vala"
	return result;
#line 292 "utils.c"
}

gboolean
peek_utils_check_for_executable (const gchar* executable)
{
	gchar** args = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar** _tmp2_;
	gint args_length1;
	gint _args_size_;
	gint status = 0;
	gchar* output = NULL;
	gchar* errorout = NULL;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 55 "../src/utils.vala"
	g_return_val_if_fail (executable != NULL, FALSE);
#line 56 "../src/utils.vala"
	_tmp0_ = g_strdup ("which");
#line 56 "../src/utils.vala"
	_tmp1_ = g_strdup (executable);
#line 56 "../src/utils.vala"
	_tmp2_ = g_new0 (gchar*, 2 + 1);
#line 56 "../src/utils.vala"
	_tmp2_[0] = _tmp0_;
#line 56 "../src/utils.vala"
	_tmp2_[1] = _tmp1_;
#line 56 "../src/utils.vala"
	args = _tmp2_;
#line 56 "../src/utils.vala"
	args_length1 = 2;
#line 56 "../src/utils.vala"
	_args_size_ = args_length1;
#line 327 "utils.c"
	{
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		gint _tmp5_ = 0;
#line 65 "../src/utils.vala"
		g_spawn_sync (NULL, args, NULL, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp3_, &_tmp4_, &_tmp5_, &_inner_error0_);
#line 65 "../src/utils.vala"
		_g_free0 (output);
#line 65 "../src/utils.vala"
		output = _tmp3_;
#line 65 "../src/utils.vala"
		_g_free0 (errorout);
#line 65 "../src/utils.vala"
		errorout = _tmp4_;
#line 65 "../src/utils.vala"
		status = _tmp5_;
#line 65 "../src/utils.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 346 "utils.c"
			gboolean _tmp6_ = FALSE;
#line 65 "../src/utils.vala"
			if (_inner_error0_->domain == G_SPAWN_ERROR) {
#line 350 "utils.c"
				goto __catch0_g_spawn_error;
			}
#line 65 "../src/utils.vala"
			_g_free0 (errorout);
#line 65 "../src/utils.vala"
			_g_free0 (output);
#line 65 "../src/utils.vala"
			args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 65 "../src/utils.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 65 "../src/utils.vala"
			g_clear_error (&_inner_error0_);
#line 65 "../src/utils.vala"
			return _tmp6_;
#line 365 "utils.c"
		}
#line 68 "../src/utils.vala"
		g_debug ("utils.vala:68: Looking for executable %s (%i): %s%s", executable, status, output, errorout);
#line 70 "../src/utils.vala"
		result = peek_utils_is_exit_status_success (status);
#line 70 "../src/utils.vala"
		_g_free0 (errorout);
#line 70 "../src/utils.vala"
		_g_free0 (output);
#line 70 "../src/utils.vala"
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 70 "../src/utils.vala"
		return result;
#line 379 "utils.c"
	}
	goto __finally0;
	__catch0_g_spawn_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 64 "../src/utils.vala"
		e = _inner_error0_;
#line 64 "../src/utils.vala"
		_inner_error0_ = NULL;
#line 72 "../src/utils.vala"
		_tmp7_ = e;
#line 72 "../src/utils.vala"
		_tmp8_ = _tmp7_->message;
#line 72 "../src/utils.vala"
		g_debug ("utils.vala:72: Error: %s", _tmp8_);
#line 64 "../src/utils.vala"
		_g_error_free0 (e);
#line 399 "utils.c"
	}
	__finally0:
#line 64 "../src/utils.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 404 "utils.c"
		gboolean _tmp9_ = FALSE;
#line 64 "../src/utils.vala"
		_g_free0 (errorout);
#line 64 "../src/utils.vala"
		_g_free0 (output);
#line 64 "../src/utils.vala"
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 64 "../src/utils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 64 "../src/utils.vala"
		g_clear_error (&_inner_error0_);
#line 64 "../src/utils.vala"
		return _tmp9_;
#line 418 "utils.c"
	}
#line 75 "../src/utils.vala"
	result = FALSE;
#line 75 "../src/utils.vala"
	_g_free0 (errorout);
#line 75 "../src/utils.vala"
	_g_free0 (output);
#line 75 "../src/utils.vala"
	args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 75 "../src/utils.vala"
	return result;
#line 430 "utils.c"
}

gchar*
peek_utils_get_file_extension_for_format (PeekOutputFormat output_format)
{
	gchar* _tmp0_;
	gchar* result;
#line 79 "../src/utils.vala"
	_tmp0_ = peek_output_format_to_string (output_format);
#line 79 "../src/utils.vala"
	result = _tmp0_;
#line 79 "../src/utils.vala"
	return result;
#line 444 "utils.c"
}

static gboolean
string_get_next_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result;
#line 1259 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1260 "glib-2.0.vapi"
	_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
#line 1261 "glib-2.0.vapi"
	if (_vala_c != ((gunichar) 0)) {
#line 460 "utils.c"
		gchar* _tmp0_;
#line 1262 "glib-2.0.vapi"
		_tmp0_ = g_utf8_next_char (((gchar*) self) + (*index));
#line 1262 "glib-2.0.vapi"
		*index = (gint) (_tmp0_ - ((gchar*) self));
#line 1263 "glib-2.0.vapi"
		result = TRUE;
#line 1263 "glib-2.0.vapi"
		if (c) {
#line 1263 "glib-2.0.vapi"
			*c = _vala_c;
#line 472 "utils.c"
		}
#line 1263 "glib-2.0.vapi"
		return result;
#line 476 "utils.c"
	} else {
#line 1265 "glib-2.0.vapi"
		result = FALSE;
#line 1265 "glib-2.0.vapi"
		if (c) {
#line 1265 "glib-2.0.vapi"
			*c = _vala_c;
#line 484 "utils.c"
		}
#line 1265 "glib-2.0.vapi"
		return result;
#line 488 "utils.c"
	}
}

gboolean
peek_utils_string_is_empty (const gchar* str)
{
	gunichar c = 0U;
	gboolean result;
#line 83 "../src/utils.vala"
	if (str == NULL) {
#line 83 "../src/utils.vala"
		result = TRUE;
#line 83 "../src/utils.vala"
		return result;
#line 503 "utils.c"
	}
	{
		gint i = 0;
#line 86 "../src/utils.vala"
		i = 0;
#line 509 "utils.c"
		{
			gboolean _tmp0_ = FALSE;
#line 86 "../src/utils.vala"
			_tmp0_ = TRUE;
#line 86 "../src/utils.vala"
			while (TRUE) {
#line 516 "utils.c"
				gunichar _tmp1_ = 0U;
				gboolean _tmp2_;
				gboolean _tmp3_ = FALSE;
#line 86 "../src/utils.vala"
				if (!_tmp0_) {
#line 522 "utils.c"
				}
#line 86 "../src/utils.vala"
				_tmp0_ = FALSE;
#line 86 "../src/utils.vala"
				_tmp2_ = string_get_next_char (str, &i, &_tmp1_);
#line 86 "../src/utils.vala"
				c = _tmp1_;
#line 86 "../src/utils.vala"
				if (!_tmp2_) {
#line 86 "../src/utils.vala"
					break;
#line 534 "utils.c"
				}
#line 87 "../src/utils.vala"
				if (!g_unichar_isspace (c)) {
#line 87 "../src/utils.vala"
					_tmp3_ = !g_unichar_iscntrl (c);
#line 540 "utils.c"
				} else {
#line 87 "../src/utils.vala"
					_tmp3_ = FALSE;
#line 544 "utils.c"
				}
#line 87 "../src/utils.vala"
				if (_tmp3_) {
#line 87 "../src/utils.vala"
					result = FALSE;
#line 87 "../src/utils.vala"
					return result;
#line 552 "utils.c"
				}
			}
		}
	}
#line 90 "../src/utils.vala"
	result = TRUE;
#line 90 "../src/utils.vala"
	return result;
#line 561 "utils.c"
}

gint
peek_utils_make_even (gint i)
{
	gint result;
#line 94 "../src/utils.vala"
	result = (i / 2) * 2;
#line 94 "../src/utils.vala"
	return result;
#line 572 "utils.c"
}

/**
    * Returns available system memory in kiB.
    * Returns -1 if memory could not be read
    */
static gchar*
g_file_stream_read_line (FILE* self)
{
	gint c = 0;
	GString* ret = NULL;
	GString* _tmp3_;
	gchar* result;
#line 4064 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 4066 "glib-2.0.vapi"
	ret = NULL;
#line 4067 "glib-2.0.vapi"
	while (TRUE) {
#line 592 "utils.c"
		GString* _tmp0_;
		GString* _tmp2_;
#line 4067 "glib-2.0.vapi"
		c = fgetc (self);
#line 4067 "glib-2.0.vapi"
		if (!(c != EOF)) {
#line 4067 "glib-2.0.vapi"
			break;
#line 601 "utils.c"
		}
#line 4068 "glib-2.0.vapi"
		_tmp0_ = ret;
#line 4068 "glib-2.0.vapi"
		if (_tmp0_ == NULL) {
#line 607 "utils.c"
			GString* _tmp1_;
#line 4069 "glib-2.0.vapi"
			_tmp1_ = g_string_new ("");
#line 4069 "glib-2.0.vapi"
			_g_string_free0 (ret);
#line 4069 "glib-2.0.vapi"
			ret = _tmp1_;
#line 615 "utils.c"
		}
#line 4071 "glib-2.0.vapi"
		if (c == ((gint) '\n')) {
#line 4072 "glib-2.0.vapi"
			break;
#line 621 "utils.c"
		}
#line 4074 "glib-2.0.vapi"
		_tmp2_ = ret;
#line 4074 "glib-2.0.vapi"
		g_string_append_c ((GString*) _tmp2_, (gchar) c);
#line 627 "utils.c"
	}
#line 4076 "glib-2.0.vapi"
	_tmp3_ = ret;
#line 4076 "glib-2.0.vapi"
	if (_tmp3_ == NULL) {
#line 4077 "glib-2.0.vapi"
		result = NULL;
#line 4077 "glib-2.0.vapi"
		_g_string_free0 (ret);
#line 4077 "glib-2.0.vapi"
		return result;
#line 639 "utils.c"
	} else {
		GString* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
#line 4079 "glib-2.0.vapi"
		_tmp4_ = ret;
#line 4079 "glib-2.0.vapi"
		_tmp5_ = ((GString*) _tmp4_)->str;
#line 4079 "glib-2.0.vapi"
		_tmp6_ = g_strdup (_tmp5_);
#line 4079 "glib-2.0.vapi"
		result = _tmp6_;
#line 4079 "glib-2.0.vapi"
		_g_string_free0 (ret);
#line 4079 "glib-2.0.vapi"
		return result;
#line 656 "utils.c"
	}
}

gint
peek_utils_get_available_system_memory (void)
{
	FILE* stream = NULL;
	FILE* _tmp0_;
	FILE* _tmp1_;
	gchar* line = NULL;
	gint result;
#line 102 "../src/utils.vala"
	_tmp0_ = g_fopen ("/proc/meminfo", "r");
#line 102 "../src/utils.vala"
	stream = _tmp0_;
#line 103 "../src/utils.vala"
	_tmp1_ = stream;
#line 103 "../src/utils.vala"
	_vala_assert (_tmp1_ != NULL, "stream != null");
#line 106 "../src/utils.vala"
	while (TRUE) {
#line 678 "utils.c"
		FILE* _tmp2_;
		gchar* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
#line 106 "../src/utils.vala"
		_tmp2_ = stream;
#line 106 "../src/utils.vala"
		_tmp3_ = g_file_stream_read_line (_tmp2_);
#line 106 "../src/utils.vala"
		_g_free0 (line);
#line 106 "../src/utils.vala"
		line = _tmp3_;
#line 106 "../src/utils.vala"
		_tmp4_ = line;
#line 106 "../src/utils.vala"
		if (!(_tmp4_ != NULL)) {
#line 106 "../src/utils.vala"
			break;
#line 697 "utils.c"
		}
#line 107 "../src/utils.vala"
		_tmp5_ = line;
#line 107 "../src/utils.vala"
		if (g_str_has_prefix (_tmp5_, "MemAvailable")) {
#line 703 "utils.c"
			gint memory = 0;
			const gchar* _tmp6_;
#line 108 "../src/utils.vala"
			memory = 0;
#line 109 "../src/utils.vala"
			_tmp6_ = line;
#line 109 "../src/utils.vala"
			sscanf (_tmp6_, "MemAvailable: %d kB", &memory);
#line 110 "../src/utils.vala"
			result = memory;
#line 110 "../src/utils.vala"
			_g_free0 (line);
#line 110 "../src/utils.vala"
			_fclose0 (stream);
#line 110 "../src/utils.vala"
			return result;
#line 720 "utils.c"
		}
	}
#line 114 "../src/utils.vala"
	result = -1;
#line 114 "../src/utils.vala"
	_g_free0 (line);
#line 114 "../src/utils.vala"
	_fclose0 (stream);
#line 114 "../src/utils.vala"
	return result;
#line 731 "utils.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 128 "../src/utils.vala"
	return self ? g_object_ref (self) : NULL;
#line 739 "utils.c"
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1208 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1209 "glib-2.0.vapi"
		separator = "";
#line 753 "utils.c"
	}
#line 1211 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 757 "utils.c"
		gboolean _tmp1_ = FALSE;
#line 1211 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1211 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 763 "utils.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1211 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 768 "utils.c"
				const gchar* _tmp3_;
#line 1211 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1211 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 774 "utils.c"
			} else {
#line 1211 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 778 "utils.c"
			}
#line 1211 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 782 "utils.c"
		}
#line 1211 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 786 "utils.c"
	} else {
#line 1211 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 790 "utils.c"
	}
#line 1211 "glib-2.0.vapi"
	if (_tmp0_) {
#line 794 "utils.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1213 "glib-2.0.vapi"
		len = (gsize) 1;
#line 809 "utils.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1214 "glib-2.0.vapi"
			i = 0;
#line 1214 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1214 "glib-2.0.vapi"
			while (TRUE) {
#line 818 "utils.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1214 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 825 "utils.c"
					gint _tmp5_;
#line 1214 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1214 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 831 "utils.c"
				}
#line 1214 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1214 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1214 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 839 "utils.c"
				} else {
#line 1214 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 843 "utils.c"
				}
#line 1214 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1214 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 849 "utils.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1214 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 854 "utils.c"
						const gchar* _tmp9_;
#line 1214 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1214 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 860 "utils.c"
					} else {
#line 1214 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 864 "utils.c"
					}
#line 1214 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 868 "utils.c"
				}
#line 1214 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1214 "glib-2.0.vapi"
					break;
#line 874 "utils.c"
				}
#line 1215 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1215 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 880 "utils.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1215 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1215 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1215 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1215 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 892 "utils.c"
				} else {
#line 1215 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 896 "utils.c"
				}
#line 1215 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 900 "utils.c"
			}
		}
#line 1217 "glib-2.0.vapi"
		if (i == 0) {
#line 905 "utils.c"
			gchar* _tmp15_;
#line 1218 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1218 "glib-2.0.vapi"
			result = _tmp15_;
#line 1218 "glib-2.0.vapi"
			return result;
#line 913 "utils.c"
		}
#line 1220 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1221 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1221 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1221 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1223 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1223 "glib-2.0.vapi"
		res = _tmp18_;
#line 1224 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1224 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 931 "utils.c"
			const gchar* _tmp21_;
#line 1224 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1224 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 937 "utils.c"
		} else {
#line 1224 "glib-2.0.vapi"
			_tmp19_ = "";
#line 941 "utils.c"
		}
#line 1224 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1224 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1224 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 949 "utils.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1225 "glib-2.0.vapi"
			i = 1;
#line 1225 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1225 "glib-2.0.vapi"
			while (TRUE) {
#line 958 "utils.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1225 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 967 "utils.c"
					gint _tmp25_;
#line 1225 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1225 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 973 "utils.c"
				}
#line 1225 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1225 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1225 "glib-2.0.vapi"
					break;
#line 981 "utils.c"
				}
#line 1226 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1226 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1226 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1227 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1227 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 993 "utils.c"
					const gchar* _tmp30_;
#line 1227 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1227 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 999 "utils.c"
				} else {
#line 1227 "glib-2.0.vapi"
					_tmp28_ = "";
#line 1003 "utils.c"
				}
#line 1227 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1227 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1227 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 1011 "utils.c"
			}
		}
#line 1230 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1230 "glib-2.0.vapi"
		res = NULL;
#line 1230 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1230 "glib-2.0.vapi"
		return result;
#line 1022 "utils.c"
	} else {
		gchar* _tmp34_;
#line 1232 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1232 "glib-2.0.vapi"
		result = _tmp34_;
#line 1232 "glib-2.0.vapi"
		return result;
#line 1031 "utils.c"
	}
}

gchar*
peek_utils_get_command_failed_message (gchar** argv,
                                       gint argv_length1,
                                       GSubprocess* subprocess)
{
	gint status = 0;
	gint term_sig = 0;
	gchar* output = NULL;
	gchar* message = NULL;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* result;
#line 118 "../src/utils.vala"
	status = -1;
#line 119 "../src/utils.vala"
	term_sig = 0;
#line 120 "../src/utils.vala"
	output = NULL;
#line 122 "../src/utils.vala"
	if (subprocess != NULL) {
#line 1058 "utils.c"
		GInputStream* stdout_pipe = NULL;
		GInputStream* _tmp0_;
		GInputStream* _tmp1_;
		GInputStream* _tmp2_;
#line 123 "../src/utils.vala"
		status = g_subprocess_get_status (subprocess);
#line 124 "../src/utils.vala"
		if (g_subprocess_get_if_signaled (subprocess)) {
#line 125 "../src/utils.vala"
			term_sig = g_subprocess_get_term_sig (subprocess);
#line 1069 "utils.c"
		}
#line 128 "../src/utils.vala"
		_tmp0_ = g_subprocess_get_stdout_pipe (subprocess);
#line 128 "../src/utils.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 128 "../src/utils.vala"
		stdout_pipe = _tmp1_;
#line 129 "../src/utils.vala"
		_tmp2_ = stdout_pipe;
#line 129 "../src/utils.vala"
		if (_tmp2_ != NULL) {
#line 1081 "utils.c"
			GInputStream* _tmp3_;
			gchar* _tmp4_;
#line 130 "../src/utils.vala"
			_tmp3_ = stdout_pipe;
#line 130 "../src/utils.vala"
			_tmp4_ = peek_utils_read_instream_as_utf8 (_tmp3_);
#line 130 "../src/utils.vala"
			_g_free0 (output);
#line 130 "../src/utils.vala"
			output = _tmp4_;
#line 1092 "utils.c"
		}
#line 122 "../src/utils.vala"
		_g_object_unref0 (stdout_pipe);
#line 1096 "utils.c"
	}
#line 134 "../src/utils.vala"
	_tmp5_ = _vala_g_strjoinv (" ", argv, (gint) argv_length1);
#line 134 "../src/utils.vala"
	_tmp6_ = _tmp5_;
#line 134 "../src/utils.vala"
	_tmp7_ = g_strdup_printf ("Command \"%s\" failed with status %i (received signal %i).", _tmp6_, status, term_sig);
#line 134 "../src/utils.vala"
	_tmp8_ = _tmp7_;
#line 134 "../src/utils.vala"
	_g_free0 (_tmp6_);
#line 134 "../src/utils.vala"
	message = _tmp8_;
#line 137 "../src/utils.vala"
	_tmp9_ = output;
#line 137 "../src/utils.vala"
	if (_tmp9_ != NULL) {
#line 1114 "utils.c"
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 138 "../src/utils.vala"
		_tmp10_ = message;
#line 138 "../src/utils.vala"
		_tmp11_ = output;
#line 138 "../src/utils.vala"
		_tmp12_ = g_strdup_printf ("\n\nOutput:\n%s", _tmp11_);
#line 138 "../src/utils.vala"
		_tmp13_ = _tmp12_;
#line 138 "../src/utils.vala"
		_tmp14_ = g_strconcat (_tmp10_, _tmp13_, NULL);
#line 138 "../src/utils.vala"
		_g_free0 (message);
#line 138 "../src/utils.vala"
		message = _tmp14_;
#line 138 "../src/utils.vala"
		_g_free0 (_tmp13_);
#line 1136 "utils.c"
	}
#line 141 "../src/utils.vala"
	result = message;
#line 141 "../src/utils.vala"
	_g_free0 (output);
#line 141 "../src/utils.vala"
	return result;
#line 1144 "utils.c"
}

static gchar*
peek_utils_read_instream_as_utf8 (GInputStream* stream)
{
	GString* output = NULL;
	GString* _tmp0_;
	GDataInputStream* dis = NULL;
	GDataInputStream* _tmp1_;
	gchar* line = NULL;
	GString* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 144 "../src/utils.vala"
	g_return_val_if_fail (stream != NULL, NULL);
#line 145 "../src/utils.vala"
	_tmp0_ = g_string_new ("");
#line 145 "../src/utils.vala"
	output = _tmp0_;
#line 146 "../src/utils.vala"
	_tmp1_ = g_data_input_stream_new (stream);
#line 146 "../src/utils.vala"
	dis = _tmp1_;
#line 1170 "utils.c"
	{
#line 150 "../src/utils.vala"
		while (TRUE) {
#line 1174 "utils.c"
			gchar* _tmp2_ = NULL;
			GDataInputStream* _tmp3_;
			gchar* _tmp4_;
			gchar* _tmp5_;
			const gchar* _tmp6_;
			GString* _tmp7_;
			const gchar* _tmp8_;
#line 150 "../src/utils.vala"
			_tmp3_ = dis;
#line 150 "../src/utils.vala"
			_tmp4_ = g_data_input_stream_read_line_utf8 (_tmp3_, NULL, NULL, &_inner_error0_);
#line 150 "../src/utils.vala"
			_tmp2_ = _tmp4_;
#line 150 "../src/utils.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 150 "../src/utils.vala"
				if (_inner_error0_->domain == G_IO_ERROR) {
#line 1192 "utils.c"
					goto __catch0_g_io_error;
				}
#line 150 "../src/utils.vala"
				_g_free0 (line);
#line 150 "../src/utils.vala"
				_g_object_unref0 (dis);
#line 150 "../src/utils.vala"
				_g_string_free0 (output);
#line 150 "../src/utils.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 150 "../src/utils.vala"
				g_clear_error (&_inner_error0_);
#line 150 "../src/utils.vala"
				return NULL;
#line 1207 "utils.c"
			}
#line 150 "../src/utils.vala"
			_tmp5_ = _tmp2_;
#line 150 "../src/utils.vala"
			_tmp2_ = NULL;
#line 150 "../src/utils.vala"
			_g_free0 (line);
#line 150 "../src/utils.vala"
			line = _tmp5_;
#line 150 "../src/utils.vala"
			_tmp6_ = line;
#line 150 "../src/utils.vala"
			if (!(_tmp6_ != NULL)) {
#line 150 "../src/utils.vala"
				_g_free0 (_tmp2_);
#line 150 "../src/utils.vala"
				break;
#line 1225 "utils.c"
			}
#line 151 "../src/utils.vala"
			_tmp7_ = output;
#line 151 "../src/utils.vala"
			_tmp8_ = line;
#line 151 "../src/utils.vala"
			g_string_append (_tmp7_, _tmp8_);
#line 150 "../src/utils.vala"
			_g_free0 (_tmp2_);
#line 1235 "utils.c"
		}
	}
	goto __finally0;
	__catch0_g_io_error:
	{
		GError* e = NULL;
		FILE* _tmp9_;
		GError* _tmp10_;
		const gchar* _tmp11_;
#line 149 "../src/utils.vala"
		e = _inner_error0_;
#line 149 "../src/utils.vala"
		_inner_error0_ = NULL;
#line 154 "../src/utils.vala"
		_tmp9_ = stderr;
#line 154 "../src/utils.vala"
		_tmp10_ = e;
#line 154 "../src/utils.vala"
		_tmp11_ = _tmp10_->message;
#line 154 "../src/utils.vala"
		fprintf (_tmp9_, "Error: %s\n", _tmp11_);
#line 155 "../src/utils.vala"
		result = NULL;
#line 155 "../src/utils.vala"
		_g_error_free0 (e);
#line 155 "../src/utils.vala"
		_g_free0 (line);
#line 155 "../src/utils.vala"
		_g_object_unref0 (dis);
#line 155 "../src/utils.vala"
		_g_string_free0 (output);
#line 155 "../src/utils.vala"
		return result;
#line 1269 "utils.c"
	}
	__finally0:
#line 149 "../src/utils.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 149 "../src/utils.vala"
		_g_free0 (line);
#line 149 "../src/utils.vala"
		_g_object_unref0 (dis);
#line 149 "../src/utils.vala"
		_g_string_free0 (output);
#line 149 "../src/utils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 149 "../src/utils.vala"
		g_clear_error (&_inner_error0_);
#line 149 "../src/utils.vala"
		return NULL;
#line 1286 "utils.c"
	}
#line 158 "../src/utils.vala"
	_tmp12_ = output;
#line 158 "../src/utils.vala"
	_tmp13_ = _tmp12_->str;
#line 158 "../src/utils.vala"
	_tmp14_ = g_strdup (_tmp13_);
#line 158 "../src/utils.vala"
	result = _tmp14_;
#line 158 "../src/utils.vala"
	_g_free0 (line);
#line 158 "../src/utils.vala"
	_g_object_unref0 (dis);
#line 158 "../src/utils.vala"
	_g_string_free0 (output);
#line 158 "../src/utils.vala"
	return result;
#line 1304 "utils.c"
}

gchar*
peek_utils_format_time (gint64 seconds)
{
	gchar* _tmp0_;
	gchar* result;
#line 164 "../src/utils.vala"
	_tmp0_ = g_strdup_printf (PEEK_UTILS_TIME_FORMAT, seconds / 60, seconds % 60);
#line 164 "../src/utils.vala"
	result = _tmp0_;
#line 164 "../src/utils.vala"
	return result;
#line 1318 "utils.c"
}

PeekUtils*
peek_utils_construct (GType object_type)
{
	PeekUtils* self = NULL;
#line 12 "../src/utils.vala"
	self = (PeekUtils*) g_type_create_instance (object_type);
#line 12 "../src/utils.vala"
	return self;
#line 1329 "utils.c"
}

PeekUtils*
peek_utils_new (void)
{
#line 12 "../src/utils.vala"
	return peek_utils_construct (PEEK_TYPE_UTILS);
#line 1337 "utils.c"
}

static void
peek_value_utils_init (GValue* value)
{
#line 12 "../src/utils.vala"
	value->data[0].v_pointer = NULL;
#line 1345 "utils.c"
}

static void
peek_value_utils_free_value (GValue* value)
{
#line 12 "../src/utils.vala"
	if (value->data[0].v_pointer) {
#line 12 "../src/utils.vala"
		peek_utils_unref (value->data[0].v_pointer);
#line 1355 "utils.c"
	}
}

static void
peek_value_utils_copy_value (const GValue* src_value,
                             GValue* dest_value)
{
#line 12 "../src/utils.vala"
	if (src_value->data[0].v_pointer) {
#line 12 "../src/utils.vala"
		dest_value->data[0].v_pointer = peek_utils_ref (src_value->data[0].v_pointer);
#line 1367 "utils.c"
	} else {
#line 12 "../src/utils.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1371 "utils.c"
	}
}

static gpointer
peek_value_utils_peek_pointer (const GValue* value)
{
#line 12 "../src/utils.vala"
	return value->data[0].v_pointer;
#line 1380 "utils.c"
}

static gchar*
peek_value_utils_collect_value (GValue* value,
                                guint n_collect_values,
                                GTypeCValue* collect_values,
                                guint collect_flags)
{
#line 12 "../src/utils.vala"
	if (collect_values[0].v_pointer) {
#line 1391 "utils.c"
		PeekUtils * object;
		object = collect_values[0].v_pointer;
#line 12 "../src/utils.vala"
		if (object->parent_instance.g_class == NULL) {
#line 12 "../src/utils.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1398 "utils.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 12 "../src/utils.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1402 "utils.c"
		}
#line 12 "../src/utils.vala"
		value->data[0].v_pointer = peek_utils_ref (object);
#line 1406 "utils.c"
	} else {
#line 12 "../src/utils.vala"
		value->data[0].v_pointer = NULL;
#line 1410 "utils.c"
	}
#line 12 "../src/utils.vala"
	return NULL;
#line 1414 "utils.c"
}

static gchar*
peek_value_utils_lcopy_value (const GValue* value,
                              guint n_collect_values,
                              GTypeCValue* collect_values,
                              guint collect_flags)
{
	PeekUtils ** object_p;
	object_p = collect_values[0].v_pointer;
#line 12 "../src/utils.vala"
	if (!object_p) {
#line 12 "../src/utils.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1429 "utils.c"
	}
#line 12 "../src/utils.vala"
	if (!value->data[0].v_pointer) {
#line 12 "../src/utils.vala"
		*object_p = NULL;
#line 1435 "utils.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 12 "../src/utils.vala"
		*object_p = value->data[0].v_pointer;
#line 1439 "utils.c"
	} else {
#line 12 "../src/utils.vala"
		*object_p = peek_utils_ref (value->data[0].v_pointer);
#line 1443 "utils.c"
	}
#line 12 "../src/utils.vala"
	return NULL;
#line 1447 "utils.c"
}

GParamSpec*
peek_param_spec_utils (const gchar* name,
                       const gchar* nick,
                       const gchar* blurb,
                       GType object_type,
                       GParamFlags flags)
{
	PeekParamSpecUtils* spec;
#line 12 "../src/utils.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PEEK_TYPE_UTILS), NULL);
#line 12 "../src/utils.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 12 "../src/utils.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 12 "../src/utils.vala"
	return G_PARAM_SPEC (spec);
#line 1466 "utils.c"
}

gpointer
peek_value_get_utils (const GValue* value)
{
#line 12 "../src/utils.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PEEK_TYPE_UTILS), NULL);
#line 12 "../src/utils.vala"
	return value->data[0].v_pointer;
#line 1476 "utils.c"
}

void
peek_value_set_utils (GValue* value,
                      gpointer v_object)
{
	PeekUtils * old;
#line 12 "../src/utils.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PEEK_TYPE_UTILS));
#line 12 "../src/utils.vala"
	old = value->data[0].v_pointer;
#line 12 "../src/utils.vala"
	if (v_object) {
#line 12 "../src/utils.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PEEK_TYPE_UTILS));
#line 12 "../src/utils.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 12 "../src/utils.vala"
		value->data[0].v_pointer = v_object;
#line 12 "../src/utils.vala"
		peek_utils_ref (value->data[0].v_pointer);
#line 1498 "utils.c"
	} else {
#line 12 "../src/utils.vala"
		value->data[0].v_pointer = NULL;
#line 1502 "utils.c"
	}
#line 12 "../src/utils.vala"
	if (old) {
#line 12 "../src/utils.vala"
		peek_utils_unref (old);
#line 1508 "utils.c"
	}
}

void
peek_value_take_utils (GValue* value,
                       gpointer v_object)
{
	PeekUtils * old;
#line 12 "../src/utils.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PEEK_TYPE_UTILS));
#line 12 "../src/utils.vala"
	old = value->data[0].v_pointer;
#line 12 "../src/utils.vala"
	if (v_object) {
#line 12 "../src/utils.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PEEK_TYPE_UTILS));
#line 12 "../src/utils.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 12 "../src/utils.vala"
		value->data[0].v_pointer = v_object;
#line 1529 "utils.c"
	} else {
#line 12 "../src/utils.vala"
		value->data[0].v_pointer = NULL;
#line 1533 "utils.c"
	}
#line 12 "../src/utils.vala"
	if (old) {
#line 12 "../src/utils.vala"
		peek_utils_unref (old);
#line 1539 "utils.c"
	}
}

static void
peek_utils_class_init (PeekUtilsClass * klass,
                       gpointer klass_data)
{
#line 12 "../src/utils.vala"
	peek_utils_parent_class = g_type_class_peek_parent (klass);
#line 12 "../src/utils.vala"
	((PeekUtilsClass *) klass)->finalize = peek_utils_finalize;
#line 1551 "utils.c"
}

static void
peek_utils_instance_init (PeekUtils * self,
                          gpointer klass)
{
#line 12 "../src/utils.vala"
	self->ref_count = 1;
#line 1560 "utils.c"
}

static void
peek_utils_finalize (PeekUtils * obj)
{
	PeekUtils * self;
#line 12 "../src/utils.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PEEK_TYPE_UTILS, PeekUtils);
#line 12 "../src/utils.vala"
	g_signal_handlers_destroy (self);
#line 1571 "utils.c"
}

static GType
peek_utils_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { peek_value_utils_init, peek_value_utils_free_value, peek_value_utils_copy_value, peek_value_utils_peek_pointer, "p", peek_value_utils_collect_value, "p", peek_value_utils_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PeekUtilsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) peek_utils_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PeekUtils), 0, (GInstanceInitFunc) peek_utils_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType peek_utils_type_id;
	peek_utils_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PeekUtils", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return peek_utils_type_id;
}

GType
peek_utils_get_type (void)
{
	static volatile gsize peek_utils_type_id__once = 0;
	if (g_once_init_enter (&peek_utils_type_id__once)) {
		GType peek_utils_type_id;
		peek_utils_type_id = peek_utils_get_type_once ();
		g_once_init_leave (&peek_utils_type_id__once, peek_utils_type_id);
	}
	return peek_utils_type_id__once;
}

gpointer
peek_utils_ref (gpointer instance)
{
	PeekUtils * self;
	self = instance;
#line 12 "../src/utils.vala"
	g_atomic_int_inc (&self->ref_count);
#line 12 "../src/utils.vala"
	return instance;
#line 1606 "utils.c"
}

void
peek_utils_unref (gpointer instance)
{
	PeekUtils * self;
	self = instance;
#line 12 "../src/utils.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 12 "../src/utils.vala"
		PEEK_UTILS_GET_CLASS (self)->finalize (self);
#line 12 "../src/utils.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1620 "utils.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

